/*
 * Copyright (c) 2013 Cisco Systems, Inc. and others.  All rights reserved.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v1.0 which accompanies this distribution,
 * and is available at http://www.eclipse.org/legal/epl-v10.html
 */
package org.opendaylight.controller.sal.core.api.model;

import org.opendaylight.yangtools.yang.model.repo.api.YangTextSchemaSource;
import org.opendaylight.yangtools.yang.model.repo.spi.SchemaSourceProvider;

/**
 * Concrete source provider for text based yang sources. Suitable when trying to avoid
 * generics e.g. when exposing a source provider into config subsystem.
 */
public interface YangTextSourceProvider extends SchemaSourceProvider<YangTextSchemaSource> {
}
